PlanBuilderTask
Date: 2014-06-04

org.gcube.vremanagement.resourcebroker.impl.planbuilders

## Class PlanBuilderTask

- java.lang.Object
- - org.gcube.vremanagement.resourcebroker.impl.planbuilders.PlanBuilderTask

- Direct Known Subclasses:
    AddRequirements, AssignGHNTask, HandleRequirementsTask, InitializeScopeTask, PreselectedGHNTask, PrintRequestTask, SuggestedGHNTask, ValidateResponseTask

      public abstract class PlanBuilderTask
      extends java.lang.Object

  A generic task that operates over `PlanBuilderElem`.
  Author:
    Daniele Strollo (ISTI-CNR)

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `PlanBuilderTask()` Constructor for `PlanBuilderTask`.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `abstract PlanBuilderElem` | `makeDecision(PlanBuilderElem input)` Declares a decision making strategy over `PlanBuilderElem` elements.
    `void` | `setID(PlanBuilderIdentifier id)`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### PlanBuilderTask

          public PlanBuilderTask()

      Constructor for `PlanBuilderTask`.

  - ### Method Detail

    - #### setID

          public void setID(PlanBuilderIdentifier id)

    - #### makeDecision

          public abstract PlanBuilderElem makeDecision(PlanBuilderElem input)
                                                throws PlanBuilderException

      Declares a decision making strategy over `PlanBuilderElem` elements.
      Parameters:
        `input` - `PlanBuilderElem` the required data to make a decision plan.
      Returns:
        an element of type `PlanBuilderElem` with the initial request and response possibly modified in accordance to the decision making strategy.
      Throws:
        `GCUBEFault` - in case of internal failure an exception is thrown.
        `PlanBuilderException`